PROGRAM JACKEDIT;  { The Gem Trader P. D. Editor Utility }

USES CRT, GoldWin, GoldFast, GoldRead, GoldMisc, ChasWare;

     {$I TradeVar.inc}    {January 2011 Beta}

     { v1.20 status: Officially released December 16th, 2007. }
     { =================================================================================== }

CONST Version: STRING = 'v1.26 beta';
            {01/04/10: use v1.24 beta. 01/18/10: use v1.25 beta}
            {03/08/10: use v1.26 beta}

      Compile_Date : STRING = 'December 26, 2010.';
         {01/18/10: All code in program is fully tested.}
      { ------------------------------------------------ }

      CfgName: STRING = 'JACKEDIT.CFG';   {12/06/06: added :STRING part}

      GemPlayer_FN: STRING = 'JACKPLAY.DAT';  {07/22/05: Renamed GemPlayerFN to GemPlayer_FN.}

      RealName   = '1';   LordName   = '2';    PlayNum = '3';
      Visits     = '4';   Fairies    = '5';    Horses  = '6';
      HorseShoes = '7';   Saddles    = '8';    HitMax  = '9';
      Strength   = '0';   Defense    = 'A';    Charm   = 'B';
      Forest     = 'C';   Elixirs    = 'D';    GemsTraded = 'E';
      Adoptions  = 'F';   Potions_Ban = 'G';   ExpLost    = 'H';
      GemsLost   = 'I';   Kids_Ban    = 'J';   SkillUses  = 'K'; {08/19/05}
      { ------------------------------------------------------- }

      { Q - Quit/Save Changes.   S - Search for Player. }
      { * - New Day for Player   X - Delete Player      }
      { ------------------------------------------------------- }

      TwoBillion: LongInt = 2000000000;

      Max_Visits: BYTE = 20;  {Added 11/11/2009}
      { ------------------------------------------------ }

VAR TSearch: Trade_Player;   { for player searches }

    TGTEdit: Trade_Player;    {12/06/06: moved up to here.}
         {11/12/09: Renamed TGEdit VAR to TGTEDIT. global change}

    Editor_Path : STRING;      { File Vars for JACKPLAY.DAT access }

    Editor_File:  FILE OF Trade_Player;

    IGMDir: STRING;   {12/06/06: Changed STRING[80] to STRING.}

    RecordNum   : BYTE;

    Debug_Mode: BOOLEAN;  {Added 12/02/07}
           {01/17/10: Renamed DebugVar to Debug_Mode.}

      { TempNum, Used, Found: Accessed from TradeVar.inc.   Used }
      { in record Seek process.  }

      { Peddler_FN, TGEDit, Editor_File, IGMDir, and RecordNum }
      { values were moved here from JACKUNIT.PAS on 08/20/05. }
    { ================================================================================== }

PROCEDURE READ_CONFIG;               {Fully verified 12:44 pm 07/19/05}
  VAR Config_File: TEXT;

  PROCEDURE MakeConfig;                    {Fully verified 12:44 pm 07/19/05}
    VAR IGMLoc: STRING;  {12/06/06: Changed STRING[80] to STRING.}
  BEGIN
    IGMLoc:= PromptStr(0,0,60,'Enter directory path to GemTrade IGM',' Installation ','',FALSE);
    IGMLoc:= S2U(IGMLoc);   {12/07/06: capitalize igm path.}

    Addtext(AddBack(IGMLoc),CfgName,TRUE);
  END;   { ------------------------------------------------------------- }

BEGIN
  IF NOT Exist(CfgName) THEN MakeConfig;

  ASSIGN(Config_File,CfgName);  {12/07/06: confirmed CFGName value is JACKEDIT.CFG.}
  RESET(Config_File);
  Readln(Config_File,IGMDir);
  CLOSE(Config_File);

  IGMDir:= S2U(IGMDir);  {08/08/05}

  { 07/16/05: When run from compiler, verified that value of IGMDir is known at this point. }
END;       { Read_Config ------------------------------------------------- }


PROCEDURE READ_CUSTOMERS_FILE;    { Reads the IGM's JACKPLAY.DAT file. }
BEGIN
  {12/06/06: Verified that Peddler_FN, RecordNum are valid values.}

  Editor_Path:= S2U(IGMDIR+GemPlayer_FN);  {07/29/05} {12/07/06: added S2U}
             { 12/31/07: Renamed Peddler_FN to Editor_Path. }

  FileMode:= $12;  {12/06/06: replacement for Lockfile/Unlockfile.}

  ASSIGN(Editor_File,Editor_Path);        {verified 11:10 pm 07/15/05}
  RESET(Editor_File);

  SEEK(Editor_File,RecordNum);
  READ(Editor_File,TGTEdit);

  CLOSE(Editor_File);
END;     { ---------------------------------------------------- }


PROCEDURE WRITE_CUSTOMERS_FILE; { Writes IGM's JACKPLAY.DAT file }
BEGIN
  Editor_Path:= S2U(IGMDIR+GemPlayer_FN);  {07/29/05} {12/07/06: added S2U}
             { 12/31/07: Renamed Peddler_FN to Editor_Path. }

  FileMode:= $12;  {12/06/06: replacement for Lockfile/Unlockfile.}

  ASSIGN(Editor_File,Editor_Path);            {Fully verified 12:44 pm 07/19/05}
  RESET(Editor_File);

  SEEK(Editor_File,RecordNum);
  WRITE(Editor_File,TGTEdit);

  CLOSE(Editor_File);
END;     { WRITE_CUSTOMERS_FILE   ------------------------------ }


PROCEDURE PLAYER_SEARCH(Num:Integer);                {verified 11:10 pm 07/15/05}
      { Reads JACKPLAY.DAT. Does search on player record number }
BEGIN
  Editor_Path:= S2U(IGMDIR+GemPlayer_FN);  {07/29/05}   {12/07/06: added S2U}
             { 12/31/07: Renamed Peddler_FN to Editor_Path. }

  FileMode:= $12;  {12/06/06: replacement for Lockfile/Unlockfile.}

  ASSIGN(Editor_File,Editor_Path);
  RESET(Editor_File);

  SEEK(Editor_File,Num);
  READ(Editor_File,TSearch);

  CLOSE(Editor_File);
END;     { Search  --------------------------------------------- }


FUNCTION Get(b:CHAR): STRING;          {Fully verified 12:44 pm 07/19/05}
BEGIN
  CASE UpCase(b) OF
     RealName : Get:='`!'+TGTEdit.RealName;

     LordName : Get:='`$'+TGTEdit.LordName;        {moved entry up to here 07/11/05}

     PlayNum  : Get:='`@'+N2S(TGTEdit.PlayNum);  {Contains player's LORD player #.}

     Visits   : IF TGTEdit.Visits = 0              {Revised/Verified 07/30/05}
                  THEN  Get:= '`#None'
                  ELSE  Get:= '`$'+N2S(TGTEdit.Visits);

     Fairies  : IF TGTEdit.Fairies = 0              {Revised/Verified 07/30/05}
                  THEN  Get:= '`#None'
                  ELSE  Get:= '`$'+N2S(TGTEdit.Fairies);

     Horses   : IF TGTEdit.Horses = 0              {Revised/Verified 07/30/05}
                  THEN  Get:= '`#None'
                  ELSE  Get:= '`$'+N2S(TGTEdit.Horses);

     HorseShoes: IF TGTEdit.HorseShoes = 0              {Revised/Verified 07/30/05}
                   THEN  Get:= '`#None'
                   ELSE  Get:= '`$'+N2S(TGTEdit.HorseShoes);

     Saddles : IF TGTEdit.Saddles = 0              {Revised/Verified 07/30/05}
                 THEN  Get:= '`#None'
                 ELSE  Get:= '`$'+N2S(TGTEdit.Saddles);

     HitMax  : IF TGTEdit.HitMax = 0              {Revised/Verified 07/30/05}
                 THEN  Get:= '`#None'
                 ELSE  Get:= '`$'+COMMA(TGTEdit.HitMax);

     Strength: IF TGTEdit.Strength = 0              {Revised/Verified 07/30/05}
                 THEN  Get:= '`#None'
                 ELSE  Get:= '`$'+COMMA(TGTEdit.Strength);

     Defense : IF TGTEdit.Defense = 0              {Revised/Verified 07/30/05}
                 THEN  Get:= '`#None'
                 ELSE  Get:= '`$'+COMMA(TGTEdit.Defense);

     Charm   : IF TGTEdit.Charm = 0              {Revised/Verified 07/30/05}
                 THEN  Get:= '`#None'
                 ELSE  Get:= '`$'+COMMA(TGTEdit.Charm);

     Forest  : IF TGTEdit.Forest = 0              {Revised/Verified 07/30/05}
                 THEN  Get:= '`#None'
                 ELSE  Get:= '`$'+COMMA(TGTEdit.Forest);

     Elixirs : IF TGTEdit.Elixirs = 0              {Revised/Verified 07/30/05}
                 THEN  Get:= '`#None'
                 ELSE  Get:= '`$'+COMMA(TGTEdit.Elixirs);

     GemsTraded: IF TGTEdit.GemsTraded = 0              {Revised/Verified 07/30/05}
                   THEN  Get:= '`#None'
                   ELSE  Get:= '`$'+COMMA(TGTEdit.GemsTraded);

     Adoptions : IF TGTEdit.Adoptions = 0              {Revised/Verified 07/30/05}
                   THEN  Get:= '`#None'
                   ELSE  Get:= '`$'+COMMA(TGTEdit.Adoptions);

     Potions_Ban: IF TGTEdit.PotionsBan THEN Get:= '`@Yes! '
                    ELSE Get:= '`0Nope!';      {12/07/06: use Red for YES value.}

     ExpLost  : IF TGTEdit.ExpLost = 0              {Revised/Verified 07/30/05}
                  THEN  Get:= '`#None'
                  ELSE  Get:= '`$'+COMMA(TGTEdit.ExpLost);

     GemsLost : IF TGTEdit.GemsLost = 0              {Revised/Verified 07/30/05}
                  THEN  Get:= '`#None'
                  ELSE  Get:= '`$'+COMMA(TGTEdit.GemsLost);

     Kids_Ban : IF TGTEdit.Kids_Ban THEN Get:= '`@Yes! '   {12/07/06: used Red for Yes!}
                  ELSE Get:= '`0Nope!';   {12/07/06: used Lt. Green for Nope!}

     SkillUses: IF TGTEdit.SkillUses = 0    {Added 08/19/05: VERIFIED}
                  THEN  Get:= '`#None'
                  ELSE  Get:= '`$'+N2S(TGTEdit.SkillUses);
  END;

  CursorOff;   {09/03/08: Fixes bug found by Dennis Collins.}

    { When program's user would change a setting in a dialog box, when }
    { they returned to the main screen, the cursor would be back on the }
    { screen, so this keeps the cursor deactivated while the editor runs. }
END;     { GET Func. ----------------------------------------------------- }



{ 1 }PROCEDURE DO_REAL_NAME;          {VERIFIED 07/19/05}
BEGIN
  TGTEdit.RealName:=
  PromptStr(0,0,50,'Enter REAL name for player',' Player Real Name Change ',TGTEdit.RealName,FALSE);

  WRITE_CUSTOMERS_FILE;
  CWriteXy(22,4,Replicate(50,' '));  { Write data on position 25, Line #4. }
  CWriteXy(22,4,Get(RealName));
END;


{ 2 }PROCEDURE DO_LORD_NAME;           {VERIFIED 07/19/05}
BEGIN
  TGTEdit.LordName:=
  PromptStr(0,0,20,'Enter LORD Name for player',' Player Lord Name Change ',TGTEdit.LordName,FALSE);

  WRITE_CUSTOMERS_FILE;
  CwriteXY(22,5,Replicate(20,' '));
  CwriteXY(22,5,Get(LordName));
END;


    { In normal usage, don't allow users to change LORD Player Numbers. }
{ 3 }PROCEDURE DO_PLAYER_NUMBER;              {VERIFIED 07/19/05}
BEGIN
  TGTEdit.PlayNum:=
  PromptNum(0,0,'Enter player''s LORD Player # (0-160)?',' LORD Player Number Change ',TGTEdit.PlayNum,0,160,TRUE);

  WRITE_CUSTOMERS_FILE;
  CWriteXy(52,5,Replicate(5,' '));    { Allow room for 3 digits, and 2 blank spaces. 07/13/05}
  CWriteXy(52,5,Get(PlayNum));
END;


{ 4 }PROCEDURE Do_Visits;       {edited 09/09/09: verified}
BEGIN
  TGTEdit.Visits:=
    PromptNum(0,0,'Enter Visits Today (0-20)?',' Visits Today Change',TGTEdit.Visits,0,Max_Visits,TRUE);
        {rewrote 11/11/09 to use 0-20 range, Max_Visits const.}

  WRITE_CUSTOMERS_FILE;
  CwriteXY(22,6,Replicate(5,' '));
  CwriteXY(22,6,Get(Visits));
END;


{ 5 }PROCEDURE Do_Fairies;        {Revised 07/29/05}
BEGIN
  TGTEdit.Fairies:=
  PromptNum(0,0,'Enter Fairy Trades (0-100)?',' Fairy Trades Change',TGTEdit.Fairies,0,100,TRUE);
      { 12/05/06: Replaced Max_Fairies with 100 value. }

  WRITE_CUSTOMERS_FILE;
  CwriteXY(58,6,Replicate(5,' '));
  CwriteXY(58,6,Get(Fairies));
END;


{ 6 }PROCEDURE Do_Horses;                 {Revised 07/29/05}
BEGIN
  TGTEdit.Horses:=
  PromptNum(0,0,'Enter Horse Trades (0-100)?',' Horse Trades Change',TGTEdit.Horses,0,100,TRUE);
      { 12/05/06: Replaced 0-12 with 0-100 data editing range.}

  WRITE_CUSTOMERS_FILE;
  CWriteXY(22,7,Replicate(5,' '));
  CWriteXY(22,7,Get(Horses));
END;


{ 7 }PROCEDURE Do_HorseShoes;                 {VERIFIED 07/19/05}
BEGIN
  TGTEdit.HorseShoes:=
  PromptNum(0,0,'Enter HorseShoe Sets (0-100)?',' HorseShoe Sets Change',TGTEdit.HorseShoes,0,100,TRUE);
                              { Will be sold in sets of 4 shoes. }
      { 12/05/06: Replaced 0-12 with 0-100 data editing range.}

  WRITE_CUSTOMERS_FILE;
  CWriteXY(58,7,Replicate(4,' '));
  CWriteXY(58,7,Get(HorseShoes));
END;


{ 8 }PROCEDURE Do_Saddles;               {VERIFIED 07/19/05}
BEGIN
  TGTEdit.Saddles:=
  PromptNum(0,0,'Enter Saddles Bought (0-100)?',' Saddles Bought Change ',TGTEdit.Saddles,0,100,TRUE);
      { 12/05/06: Replaced 0-25 with 0-100 editing range. }

  WRITE_CUSTOMERS_FILE;
  CwriteXY(22,8,Replicate(4,' '));
  CwriteXY(22,8,Get(Saddles));
END;


{ 9 }PROCEDURE Do_HitMax;                 {VERIFIED 07/19/05}
BEGIN
  TGTEdit.HitMax:=
  PromptNum(0,0,'Enter Max Hit-Points (0-20,000)?',' Max HitPoints Potions Change ',TGTEdit.HitMax,0,20000,TRUE);
      { 12/05/06: Replaced 0-8000 with 0-16,000 editing range. }
      { 12/15/07: Replaced 0-16000 with 0-20,000 editing range. }

  WRITE_CUSTOMERS_FILE;
  CWriteXY(58,8,Replicate(6,' '));
  CWriteXY(58,8,Get(HitMax));
END;


{ 0 }PROCEDURE DO_Strength;                 {VERIFIED 07/19/05}
BEGIN
  TGTEdit.Strength:=
  PromptNum(0,0,'Enter Strength Points (0-20,000)?',' Strength Potions Change ',TGTEdit.Strength,0,20000,TRUE);
      { 12/05/06: Replaced 0-8000 with 0-16,000 editing range. }
      { 12/15/07: Replaced 0-16000 with 0-20,000 editing range. }

  WRITE_CUSTOMERS_FILE;
  CWriteXY(22,9,Replicate(6,' '));
  CWriteXY(22,9,Get(Strength));
END;


{ A }PROCEDURE DO_Defense;                 {VERIFIED 07/19/05}
BEGIN
  TGTEdit.Defense:=
  PromptNum(0,0,'Enter Defense Points (0-20,000)?',' Defense Potions Change ',TGTEdit.Defense,0,20000,TRUE);
      { 12/05/06: Replaced 0-8000 with 0-16,000 editing range. }
      { 12/15/07: Replaced 0-16000 with 0-20,000 editing range. }

  WRITE_CUSTOMERS_FILE;
  CWriteXY(58,9,Replicate(6,' '));
  CWriteXY(58,9,Get(Defense));
END;


{ B }PROCEDURE DO_Charm;               {VERIFIED 07/19/05}
BEGIN
  TGTEdit.Charm:=
  PromptNum(0,0,'Enter Charm Points (0-20,000)?',' Charm Potions Change ',TGTEdit.Charm,0,20000,TRUE);
      { 12/05/06: Replaced 0-8000 with 0-16,000 editing range. }
      { 12/15/07: Replaced 0-16000 with 0-20,000 editing range. }

  WRITE_CUSTOMERS_FILE;
  CwriteXY(22,10,Replicate(6,' '));
  CwriteXY(22,10,Get(Charm));
END;


{ C }PROCEDURE DO_Forest;                 {VERIFIED 07/19/05}
BEGIN
  TGTEdit.Forest:=
  PromptNum(0,0,'Enter Forest Fights  (0-16,000)?',' Forest Fights Potions Change ',TGTEdit.Forest,0,16000,TRUE);
      { 12/05/06: Replaced 0-8000 with 0-16,000 editing range. }

  WRITE_CUSTOMERS_FILE;
  CWriteXY(58,10,Replicate(6,' '));
  CWriteXY(58,10,Get(Forest));
END;


{ D }PROCEDURE Do_Elixirs;               {VERIFIED 07/19/05}
BEGIN
  TGTEdit.Elixirs:=
  PromptNum(0,0,'Enter Total Elixirs Drunk (0-21,000)?',' Total Elixirs Drunk Change ',TGTEdit.Elixirs,0,21000,TRUE);
      { 12/05/06: Replaced 0-8000 with 0-16,000 editing range. }
      { 12/06/06: reset to 17,000 for testing of Kids_Ban variable.}
      { 12/07/06: changed "Elixirs Bought" to "Total Elixirs Drunk". }
      { 12/15/07: reset to 21,000 for testing of Kids_Ban variable.}

  IF TGTEdit.Elixirs >= 20000 THEN TGTEdit.PotionsBan:= TRUE
    ELSE TGTEdit.PotionsBan:= FALSE;   {Added 12/06/06}

  WRITE_CUSTOMERS_FILE;
  CwriteXY(22,11,Replicate(6,' '));
  CwriteXY(22,11,Get(Elixirs));

  CWriteXY(58,12,Replicate(6,' '));   {12/06/06: update Potions Ban entry}
  CWriteXY(58,12,Get(Potions_Ban));   {12/06/06}
END;


{ E }PROCEDURE DO_GemsTraded;    {Revised 07/29/05}
BEGIN
  TGTEdit.GemsTraded:=
    PromptNum(0,0,'Enter Gems Traded (0-300,000)?',' Gems Traded Change',TGTEdit.GemsTraded,0,300000,TRUE);

  WRITE_CUSTOMERS_FILE;
  CWriteXY(58,11,Replicate(8,' '));
  CWriteXY(58,11,Get(GemsTraded));
END;


{ F }PROCEDURE Do_Adoptions;      {Revised 12/27/05}
BEGIN
  TGTEdit.Adoptions:=
  PromptNum(0,0,'Enter # of Adoptions (0-17,000)?',' Adoptions Change',
      TGTEdit.Adoptions,0,10000,TRUE);
      { 12/05/06: Replaced Max_Kids constant with 9000. }
      { 12/06/06: reset to 10,000 to do testing of Kids_Ban variable.}
      { 12/28/06: changed to use 0-17,000 data editing range. }

  IF TGTEdit.Adoptions >= 16000 THEN TGTEdit.Kids_Ban:= TRUE
    ELSE TGTEdit.Kids_Ban:= FALSE;   {Added 12/06/06}

  WRITE_CUSTOMERS_FILE;
  CwriteXY(22,12,Replicate(6,' '));
  CwriteXY(22,12,Get(Adoptions));

  CWriteXY(24,14,Replicate(6,' '));   {12/06/06: Update Kids Ban entry}
  CWriteXY(24,14,Get(Kids_Ban));      {12/06/06}
END;


{ G }PROCEDURE DO_Potions_Ban;                 {VERIFIED 07/19/05}
BEGIN

  { Rewrote 12/06/06 based on Doofedit syntax, which works properly, }
  { due to glitch where JACKEDIT's boolean toggles do NOT work right. }
  { However, the Glitch fix has not worked properly anyway. 01:50 am note. }

  IF TGTEdit.PotionsBan=TRUE THEN TGTEdit.PotionsBan:= FALSE
    ELSE IF TGTEdit.PotionsBan=FALSE THEN TGTEdit.PotionsBan:= TRUE;
       {12/07/06: Changed to TGTEdit.PotionsBan=TRUE removing blank }
       {spaces from before/after the = symbol. Code is working now. 1:27 pm}

      {12/07/06 01:27 pm: The G menu key status toggle is working now.}

  WRITE_CUSTOMERS_FILE;
  CWriteXY(58,12,Replicate(6,' '));
  CWriteXY(58,12,Get(Potions_Ban));
END;


{ H }PROCEDURE Do_ExpLost;               {VERIFIED 07/19/05}
BEGIN
  TGTEdit.ExpLost:=
  PromptNum(0,0,'Enter Exp Pts Lost (0-Two Billion)?',' Exp Pts Lost Change',
   TGTEdit.ExpLost,0,TwoBillion,TRUE);

  WRITE_CUSTOMERS_FILE;
  CwriteXY(22,13,Replicate(13,' '));
  CwriteXY(22,13,Get(ExpLost));
END;


{ I }PROCEDURE Do_GemsLost;               {VERIFIED 07/19/05}
BEGIN
  TGTEdit.GemsLost:=
  PromptNum(0,0,'Enter Gems Lost (0-100,000)?',' Gems Lost Change',TGTEdit.GemsLost,0,100000,TRUE);
     {Note: Use 100,000 in editor}

  WRITE_CUSTOMERS_FILE;
  CwriteXY(58,13,Replicate(9,' '));
  CwriteXY(58,13,Get(GemsLost));
END;


{ J }PROCEDURE DO_KIDS_BAN;                 {VERIFIED 07/19/05}
BEGIN
  { Rewrote 12/06/06 based on Doofedit syntax, which works properly, }
  { due to glitch where JACKEDIT's boolean toggles do NOT work right. }
  { However, the Glitch fix has not worked properly anyway. 01:50 am note. }

  IF TGTEdit.Kids_Ban = TRUE THEN TGTEdit.Kids_Ban:= FALSE
    ELSE IF TGTEdit.Kids_Ban = FALSE THEN TGTEdit.Kids_Ban:= TRUE;
      {12/07/06 01:29 pm: The J menu key status toggle is working now.}

  WRITE_CUSTOMERS_FILE;
  CWriteXY(24,14,Replicate(6,' '));
  CWriteXY(24,14,Get(Kids_Ban));
END;


{ K }PROCEDURE Do_Skill_Uses;   {Added 08/19/05: VERIFIED}
BEGIN
  TGTEdit.SkillUses:=
    PromptNum(0,0,'Enter Skill Use Points (0-50)?',' Skill Use Points Change ',TGTEdit.SkillUses,0,50,TRUE);

  WRITE_CUSTOMERS_FILE;
  CwriteXY(58,14,Replicate(4,' '));
  CwriteXY(58,14,Get(SkillUses));
END;                                  { Usage of new Stat enabled 08/19/05 3:12 am }

{ note: To use Y, N responses via keyboard, one has to use
  the ALT key. Or simply use the mouse to click on the option wanted. }


  { 11/03/05: Renamed Do_Reset_Stats back to Do_NewDay. }
{ * }PROCEDURE Do_NewDay;           {Fully verified 12:44 pm 07/19/05}
BEGIN
  CWGotoXY(5,24);
  CWriteLn('  `0Running `!"Reset Player''s Stats" `0process. 3-second delay.');
     { 08/19/05: Renamed from "Do New Day for Player". }

  DELAY(3000);

  { 10/02/05: Removed PlayNum negative reset code.  BYTE vars can't be }
  { set to negative values, so those code blocks are not needed. }

  IF (TGTEdit.PlayNum > 160) THEN
    BEGIN
      TGTEdit.PlayNum:= 160;
      PromptOK('Advisory:',' Resetting LORD Player # field to 160.');
    END;

  { --------------------------------------------------- }
  { 10/02/05: Removed negative Visits, Fairies, and Horses reset }
  { code blocks.  The BYTE vars can't be set to negative values. }

  IF TGTEdit.Visits > 0 THEN
    BEGIN
      TGTEdit.Visits:= 0;
      PromptOK('Advisory:',' Resetting the Visits Today field to Zero.');
    END;

      { --------------------------------------------------- }
            { 07/22/05: Fixed omission of code for resetting Fairies field.}
  IF TGTEdit.Fairies > 0 THEN
    BEGIN
      TGTEdit.Fairies:= 0;
      PromptOK('Advisory:',' Resetting the Fairies Bought field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TGTEdit.Horses > 0 THEN
    BEGIN
      TGTEdit.Horses:= 0;
      PromptOK('Advisory:',' Resetting the Horses Bought field to Zero.');
    END;

  { --------------------------------------------------- }
  { 10/02/05: Removed negative HorseShoes, Saddles reset code }
  { blocks.  The BYTE vars can't be set to negative values. }

  IF TGTEdit.HorseShoes > 0 THEN
    BEGIN
      TGTEdit.HorseShoes:= 0;
      PromptOK('Advisory:',' Resetting the HorseShoes Sets field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TGTEdit.Saddles > 0 THEN
    BEGIN
      TGTEdit.Saddles:= 0;
      PromptOK('Advisory:',' Resetting the Saddles field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TGTEdit.HitMax < 0 THEN
    BEGIN
      TGTEdit.HitMax:= 0;
      PromptOK('Advisory:',' Reset negative Max HitPoints field to Zero.');
    END;

  IF TGTEdit.HitMax > 0 THEN
    BEGIN
      TGTEdit.HitMax:= 0;
      PromptOK('Advisory:',' Resetting the Max HitPoints field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TGTEdit.Strength < 0 THEN
    BEGIN
      TGTEdit.Strength:= 0;
      PromptOK('Advisory:',' Reset negative Strength Points field to Zero.');
    END;

  IF TGTEdit.Strength > 0 THEN
    BEGIN
      TGTEdit.Strength:= 0;
      PromptOK('Advisory:',' Resetting the Strength Points field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TGTEdit.Defense < 0 THEN
    BEGIN
      TGTEdit.Defense:= 0;
      PromptOK('Advisory:',' Reset negative Defense Points field to Zero.');
    END;

  IF TGTEdit.Defense > 0 THEN
    BEGIN
      TGTEdit.Defense:= 0;
      PromptOK('Advisory:',' Resetting the Defense Points field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TGTEdit.Charm < 0 THEN
    BEGIN
      TGTEdit.Charm:= 0;
      PromptOK('Advisory:',' Reset negative Charm Points field to Zero.');
    END;

  IF TGTEdit.Charm > 0 THEN
    BEGIN
      TGTEdit.Charm:= 0;
      PromptOK('Advisory:',' Resetting the Charm Points field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TGTEdit.Forest < 0 THEN
    BEGIN
      TGTEdit.Forest:= 0;
      PromptOK('Advisory:',' Reset negative Forest Fights  field to Zero.');
    END;

  IF TGTEdit.Forest > 0 THEN
    BEGIN
      TGTEdit.Forest:= 0;
      PromptOK('Advisory:',' Resetting the Forest Fights  field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TGTEdit.Elixirs < 0 THEN
    BEGIN
      TGTEdit.Elixirs:= 0;
      PromptOK('Advisory:',' Reset negative Total Elixirs Drunk field to Zero.');
    END;            { 12/07/06: changed "Elixirs Bought" to "Total Elixirs Drunk". }

  IF TGTEdit.Elixirs > 0 THEN
    BEGIN
      TGTEdit.Elixirs:= 0;
      PromptOK('Advisory:',' Resetting the Total Elixirs Drunk field to Zero.');
    END;            { 12/07/06: changed "Elixirs Bought" to "Total Elixirs Drunk". }

  { --------------------------------------------------- }
  IF TGTEdit.GemsTraded < 0 THEN
    BEGIN
      TGTEdit.GemsTraded:= 0;
      PromptOK('Advisory:',' Reset negative Gems Traded field to Zero.');
    END;

  IF TGTEdit.GemsTraded > 0 THEN
    BEGIN
      TGTEdit.GemsTraded:= 0;
      PromptOK('Advisory:',' Resetting the Gems Traded field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TGTEdit.Adoptions < 0 THEN
    BEGIN
      TGTEdit.Adoptions:= 0;
      PromptOK('Advisory:',' Reset negative Adoptions field to Zero.');
    END;

  IF TGTEdit.Adoptions > 0 THEN
    BEGIN
      TGTEdit.Adoptions:= 0;
      PromptOK('Advisory:',' Resetting the Adoptions field to Zero.');
    END;

  IF TGTEdit.Adoptions > 16000 THEN  {Added 08/31/05. Edited 12/28/06}
    BEGIN
      TGTEdit.Adoptions:= 16000;             {08/31/05}
      PromptOK('Advisory:',' Resetting Adoptions to max value of 16,000.');  {08/31/05}
    END;

  { -------------------------------------- }
  TGTEdit.PotionsBan:= FALSE;

  { --------------------------------------------------- }
  IF TGTEdit.ExpLost < 0 THEN
    BEGIN
      TGTEdit.ExpLost:= 0;
      PromptOK('Advisory:',' Reset negative Exp. Points Lost field to Zero.');
    END;

  IF TGTEdit.ExpLost > 0 THEN
    BEGIN
      TGTEdit.ExpLost:= 0;
      PromptOK('Advisory:',' Resetting the Exp. Points Lost field to Zero.');
    END;

  { --------------------------------------------------- }
  IF TGTEdit.GemsLost < 0 THEN
    BEGIN
      TGTEdit.GemsLost:= 0;
      PromptOK('Advisory:',' Reset negative Gems Lost field to Zero.');
    END;

  IF TGTEdit.GemsLost > 0 THEN
    BEGIN
      TGTEdit.GemsLost:= 0;
      PromptOK('Advisory:',' Resetting the Gems Lost field to Zero.');
    END;

  { --------------------------------------------------- }
  TGTEdit.Kids_Ban:= FALSE;

  { --------------------------------------------------- }
  { 10/02/05: Removed negative SkillUses reset code block. }
  { The BYTE VAR can't be set to negative values. }

  IF TGTEdit.SkillUses > 0 THEN     {added 08/19/05}
    BEGIN
      TGTEdit.SkillUses:= 0;
      PromptOK('Advisory:',' Resetting the Skill Uses field to Zero.');
    END;
  { --------------------------------------------------- }
END;     { Do_NewDay  =============================================== }


{Note: JACKEDIT does not use/have a Do_NewDay_Testing process.}


{ Relocated GET Function farther down in JACKEDIT.PAS file 08/20/05 }

{12/02/07: renamed MaxPlayers to MAX_PLAYERS.}

FUNCTION  MAX_PLAYERS: WORD; { Gets the number of customer records }
BEGIN                                                 {Fully verified 12:44 pm 07/19/05}
  MAX_PLAYERS:=1;

  Editor_Path:= S2U(IGMDIR+GemPlayer_FN);  {07/29/05}  {12/07/06: added S2U}
             { 12/31/07: Renamed Peddler_FN to Editor_Path. }

  IF NOT Exist(Editor_Path) THEN Exit;

  FileMode:= $12;  {12/06/06: replacement for Lockfile/Unlockfile.}

  ASSIGN(Editor_File,Editor_Path);
  RESET(Editor_File);

  MAX_PLAYERS:= FileSize(Editor_File);

  CLOSE(Editor_File);
END;     { MAX_PLAYERS  --------------------------------------------- }


    { Replaced with KLBEDIT.PAS file code on 09/12/05 }
FUNCTION GetRecordNum: STRING;     {Revised to include MAX_PLAYERS data. VERIFIED 07/15/05}
BEGIN
  GetRecordNum:='`$'+N2S(RecordNum + 1)+' `%of `@'+N2S(MAX_PLAYERS);
    { 08/30/05: Changed so that first record # displayed will be 1, not 0.}
END;     { GetRecordNum ---------------------------------------------- }


       {01/20/10: Changed ShowMenu to SHOW_MENU.}
PROCEDURE SHOW_MENU;       {Fully verified 12:44 pm 07/19/05}
BEGIN
  ClrScr;
   {12/05/06: Added "Database" to program name.}

  CWriteln('`%    ** `@Gem Trader''s `0Player Database Editor `$'+Version+' `%**');  {Line 1}
  CWriteln('`#    JACKPLAY.DAT `!Record Number: `@'+GetRecordNum);              {Line 2}

  CWriteLn(' ');

  { CwGotoXY, CWriteXY notes: X is position #, Y is line #. }

  CWGotoXY(3,4);   { Line 4 }
  CWriteLN('`#(`%1`#) `!Real Name    `%: '+Get(RealName));

  { -------------------------------------------- }
  CWGotoXY(3,5);                {Line 5}
    CWrite('`#(`%2`#) `!LORD Name    `%: '+Get(LordName));

  CWGotoXY(45,5);
  CWriteLN('`#(`%3`#) `!Player #`%: '+Get(PlayNum));
  { -------------------------------------------- }

  CWGotoXY(3,6);                 {Line 6}
    CWrite('`#(`%4`#) `!Visits Today `%: '+Get(Visits));

  CWGotoXY(38,6);
  CWriteLN('`#(`%5`#) `!Fairies Bought`%: '+Get(Fairies));
  { -------------------------------------------- }

  CWGotoXY(3,7);                {Line 7}
    CWrite('`#(`%6`#) `!Horses Bought`%: '+Get(Horses));

  CWGotoXY(38,7);
  CWriteLN('`#(`%7`#) `!HorseShoes    `%: '+Get(HorseShoes));
  { -------------------------------------------- }

  CWGotoXY(3,8);                 {Line 8}
    CWrite('`#(`%8`#) `!Saddles      `%: '+Get(Saddles));

  CWGotoXY(38,8);
  CWriteLN('`#(`%9`#) `!Max HitPoints `%: '+Get(HitMax));
  { -------------------------------------------- }

  CWGotoXY(3,9);                 {Line 9}
    CWrite('`#(`%0`#) `!Strength Pts `%: '+Get(Strength));

  CWGotoXY(38,9);
  CWriteLN('`#(`%A`#) `!Defense Pts   `%: '+Get(Defense));
  { -------------------------------------------- }

  CWGotoXY(3,10);                 {Line 10}
    CWrite('`#(`%B`#) `!Charm Points `%: '+Get(Charm));

  CWGotoXY(38,10);
  CWriteLN('`#(`%C`#) `!Forest Fights `%: '+Get(Forest));
  { -------------------------------------------- }

  CWGotoXY(3,11);                 {Line 11}
    CWrite('`#(`%D`#) `!Elixirs Drunk`%: '+Get(Elixirs));
    {12/07/06: Changed "Elixirs" to "Elixirs Drunk".}

  CWGotoXY(38,11);
  CWriteLN('`#(`%E`#) `!Gems Traded   `%: '+Get(GemsTraded));
  { -------------------------------------------- }

  CWGotoXY(3,12);                 {Line 12}
    CWrite('`#(`%F`#) `!Adoptions    `%: '+Get(Adoptions));

  CWGotoXY(38,12);
  CWriteLN('`#(`%G`#) `!Potions Ban?  `%: '+Get(Potions_Ban));
  { -------------------------------------------- }

  CWGotoXY(3,13);                 {Line 13}
    CWrite('`#(`%H`#) `!Exp Pts Lost `%: '+Get(ExpLost));

  CWGotoXY(38,13);
  CWriteLN('`#(`%I`#) `!Gems Lost     `%: '+Get(GemsLost));
  { -------------------------------------------- }

  CWGotoXY(3,14);
  CWrite('`#(`%J`#) `!Adoptions Ban? `%: '+Get(Kids_Ban));

  CWGotoXY(38,14);   {08/19/05}
  CWriteLn('`#(`%K`#) `!Skill Use Pts `%: '+Get(SkillUses)); {08/19/05}
  { -------------------------------------------- }

  CWriteLn(' ');  {Blank Line, Line #15}

  { --------------------------------------------------------------- }
  CWGotoXY(3,16);
    CWrite('`2(`0S`2) `%Search by Name');
      { 12/02/07: Changed menu code from X to S for Player Search. }

  CWGotoXY(40,16);
  CWriteln('`2(`0]`2) `%Advance One Record');
  { -------------------------------------------- }

  CWGotoXY(3,17);
    CWrite('`2(`0[`2) `%Back Up One Record');

  CWGotoXY(40,17);
  CWriteln('`2(`0*`2) `%Reset Player Stats');
         { Renamed 08/19/05 from "New Day for Player". }
  { -------------------------------------------- }

  CWGotoXY(3,18);      {Added 01/17/10}
  CWriteLn('`2(`0X`2) `%Delete Current Player');   {Added 01/17/10}
         {01/20/10: Changed "Delete Player Record" to "Delete Current Player".}

  CWriteln(' ');  {Blank Line, Line #19.}  {edited 01/17/10}

  CWGotoXY(3,20);   {Edited 01/17/10}
  Cwrite('`$    Input key to change, or `%Q `$to Quit and Save.');

  IF Debug_Mode THEN    {Added 01/17/10: verified 01/18/10 6:00 pm}
    CWrite('  `@[Debug Mode] ');

END;     { SHOW_MENU  ------------------------------------------------------ }


      { 12/02/07: Changed menu code from X to S for Player Search. }
      { 01/17/10: Renamed Do_PlayerSearch to DO_PLAYER_SEARCH. }
{ S }PROCEDURE DO_PLAYER_SEARCH;
VAR Counter, YN : BYTE;
    Temp, OTemp : STRING;

BEGIN
  Editor_Path:= S2U(IGMDIR+GemPlayer_FN);  {07/29/05. Verified value 08/20/05}
                      {12/07/06: added S2U}
             { 12/31/07: Renamed Peddler_FN to Editor_Path. }

  IF NOT Exist(Editor_Path) THEN Exit;
     { if no JACKPLAY.DAT then we can't search and
       couldn't have made it here to begin with. }

  Counter:= 0;
  Temp:= PromptStr(0,0,50,' Enter full or partial name: ',' Player Search ','',FALSE);
  OTemp:= Temp;
  Temp:= S2U(Temp);  { upcase the whole string }

  REPEAT
    PLAYER_SEARCH(Counter);

    { This next evaluation is checking to see if TEMP exists anywhere in
      either field of record.  If YES, then execute the next section,
      otherwise increment counter and move on.  Note: Using FUNCTION NoColor
      to strip Lord color codes for string eval and display. }

	 IF (POS(Temp,S2U(TSearch.LordName))>0) OR (POS(Temp,NoColor(S2U(TSearch.RealName)))>0) THEN
		BEGIN
		  YN:= PromptYesNo('','Are you looking for:|'+TSearch.LordName+' known as '+NoColor(TSearch.RealName)+'?');
        IF YN=1 THEN {1 means YES answer}
          BEGIN
            RecordNum:= Counter; { LORD Player # to display matches the counter }

            READ_CUSTOMERS_FILE;
            SHOW_MENU;
            Exit; { bail out of loop since we got who we want }
          END;
      END;
    Inc(Counter);
  UNTIL Counter=MAX_PLAYERS; { End of repeat loop, repeats until we get
										to last player record. }

  { if we make it to here, then there were no matches. }

  PromptOK(' Search Error! ','No match found for '+OTemp+'!');  {02/11/04}
END;   { DO_PLAYER_SEARCH ====================================== }


{ Added 01/17/10 using modified OT20EDIT.PAS code: }

{ X }PROCEDURE DO_PLAYER_DELETION;   {Created 01/17/10: verified 01/18/10 6:00 pm}
  VAR YN: BYTE;
BEGIN
  { I hate having to bust up lines due to "line too long" error }
  { messages! The next 3 lines are all one line of code. Chas.}

  YN:= PromptYesNo
   (' Warning Will Robinson! Player Deletion! ','Are you sure you want to delete the player :|'+TGTEdit.LordName+' known'
     +' as '+NoColor(TGTEdit.RealName)+'?');

  IF YN = 1 THEN {1 means YES answer}
    BEGIN
      TGTEdit.RealName:= 'X';
      TGTEdit.LordName:= '* DELETED *';

      TGTEdit.PlayNum:= 160;

        { Note: PlayNum 160 should not be in use by any valid players.}

      TGTEdit.Visits:= 0;

      TGTEdit.Fairies:= 0;
      TGTEdit.Horses:= 0;

      TGTEdit.HorseShoes:= 0;
      TGTEdit.Saddles:= 0;
      TGTEdit.SkillUses:= 0;

      TGTEdit.HitMax:= 0;
      TGTEdit.Strength:= 0;
      TGTEdit.Defense:= 0;
      TGTEdit.Charm:= 0;
      TGTEdit.Forest:= 0;

      TGTEdit.Elixirs:= 0;
      TGTEdit.GemsTraded:= 0;
      TGTEdit.Adoptions:= 0;

      TGTEdit.PotionsBan:= FALSE;
      TGTEdit.Kids_Ban:= FALSE;

      TGTEdit.ExpLost:= 0;
      TGTEdit.GemsLost:= 0;
      { ========================================== }

      WRITE_CUSTOMERS_FILE;

      PromptOK(' Record Deletion: ','Actual record deletion will be handled by the IGM the |'
                 +'next day, when it runs the New Day maintenance process. ');

      SHOW_MENU;
    END;
END;       {  DO_PLAYER_DELETION ==============================  }


   {12/06/06: Renamed RUNEditor to RUN_EDITOR.}
PROCEDURE RUN_EDITOR;            {Fully verified 12:44 pm 07/19/05}
  VAR Ch:CHAR;
BEGIN
  SHOW_MENU;

  REPEAT
    Ch:= AInput('1234567890ABCDEFGHIJKQSX][*');   {08/20/05: Added missing X code.}
                {01/17/10: Added X code.}

    CASE Ch OF
      '1' : DO_REAL_NAME;  {11/03/05: Renamed DoRealName to Do_RealName.}

      '2' : DO_LORD_NAME;     {11/03/05: Renamed DoLordName to Do_LordName.}

      '3' : BEGIN               {Rewrote 12/02/07: verified}
              CWGotoXY(1,22);   {Show text on Line 22.}
                  {01/18/10: changed from line 25 to Line 22}

              CWriteLn('  `0The `$LORD Player Number `0field is display-only.  I don''t see ');
              CWriteLn('  `0a valid reason to allow it to be edited.  3-second delay. ');
              DELAY(3000);

              IF Debug_Mode THEN   {Added 12/02/07: VERIFIED}
                BEGIN
                  BLANK(1);
                  CWriteLn('  `0Usage of `!/DEBUG `0parameter was detected, so user is ');
                  CWriteLn('  `0allowed to modify the `#Player Number `0field.  Do so with ');
                  CWriteLn('  `@CAUTION `0because it is a `@VERY `0important database field.');
                  DELAY(3000);

                  DO_PLAYER_NUMBER;
                END;

              SHOW_MENU;
            END;

      '4' : Do_Visits;

      '5' : Do_Fairies;

      '6' : Do_Horses;

      '7' : Do_HorseShoes;

      '8' : Do_Saddles;

      '9' : Do_HitMax;

      '0' : Do_Strength;

      'A' : Do_Defense;

      'B' : Do_Charm;

      'C' : Do_Forest;

      'D' : Do_Elixirs;

      'E' : Do_GemsTraded;

      'F' : Do_Adoptions;          {Revised 12/28/06}

      'G' : DO_Potions_Ban;

      'H' : Do_ExpLost;

      'I' : Do_GemsLost;

      'J' : Do_Kids_Ban;

      'K' : Do_Skill_Uses;  {08/19/05}

      { ------------------------------------------------------ }
      { Q - reserved for QUIT/SAVE Changes command processing. }
      { ------------------------------------------------------ }

      'S' : DO_PLAYER_SEARCH;    {11/03/05: Renamed DoPlayerSearch to Do_PlayerSearch.}
           { 12/02/07: Changed menu code from X to S for Player Search. }

      { ------------------------ Added 01/17/10 --------------- }
      'X' : BEGIN               {Created 01/17/10: verified 01/18/10 6:00 pm}
              CWGotoXY(1,22);   {Show text on Line 22}

              CWriteLn('  `0The `@Delete Player Record `0option is only usable when `$JACKEDIT ');
              CWriteLn('  `0is executed in `%Debug Mode, `0using the `!/Debug `0parameter. ');
              CWriteLn('  `!This option should only be used with `@EXTREME `!caution!!         ');
                      {01/20/10: rewrote wording of third line}
                      {01/20/10: Line extended to cover up "[Debug Mode]" wording on-screen}

              DELAY(4000);     {wording layout verified}

              IF Debug_Mode THEN   {Created 01/17/10: verified 01/18/10 6:00 pm}
                BEGIN
                  BLANK(1);
                  CWriteLn('  `0Usage of `!/DEBUG `0parameter was detected, so user is allowed ');
                  CWriteLn('  `0to `#Delete this Record.  `0Do this only if absolutely necessary! ');
                  DELAY(3000);

                  DO_PLAYER_DELETION;
                END;

              SHOW_MENU;
            END;
      { ------------------------------------------------------ }

      ']' : BEGIN
              Inc(RecordNum);
              IF RecordNum > (MAX_PLAYERS - 1) THEN RecordNum:= 0;  {02/14/04 edit}
              READ_CUSTOMERS_FILE;
              SHOW_MENU;
            END;

      '[' : BEGIN
              IF RecordNum=0 THEN RecordNum:= (MAX_PLAYERS - 1)
                             ELSE Dec(RecordNum);
              READ_CUSTOMERS_FILE;
              SHOW_MENU;
            END;

      '*' : BEGIN          {08/20/05: Added BEGIN/END lines}
              Do_NewDay;

              SHOW_MENU;             {Moved out of Do_NewDay 08/20/05}

              WRITE_CUSTOMERS_FILE;   {Moved out of Do_NewDay 08/20/05}
            END;

                 { 11/03/05: Renamed Do_Reset_Stats back to Do_NewDay.}
    END;       {CASE CH - ending}
  UNTIL Ch='Q';
END;       { RUN_EDITOR ---------------------------------------------------------- }


PROCEDURE EXIT_SCREEN;             {Fully verified 12:44 pm 07/19/05}
BEGIN
  { the | character will cause a linefeed, I forget what max chars }
  { are.  Anyhow, say whatever you want here or remove it totally }
              {12/05/06: Added "Database" to program name.}

  PromptOK(' Gem Trader''s Player Database Editor Credits: ',
      'JACKEDIT.EXE '+Version+'.  Copyright 2005-2011 by Donald Tidmore. |'
            {12/21/09: updated copyright info for 2010.}

      +'** Dedicated in memory of Christopher Reeve. **** ||'
                 {added second | symbol 02/24/06}

      +'** Compile Date:  '+Compile_Date+'  January 2011 Beta. ||'
        {12/06/06: added blank line | symbol to line.}
        {11/20/07: removed period after Compile_Date.}

      {  +'v1.20 released officially on:  '+Release_Date+'  ||' }
          {edited 12/16/07}

      +'Database Path: '+Editor_Path);      {Added 4th line on 08/12/05}
             { 12/31/07: Renamed Peddler_FN to Editor_Path. }

      {12/12/06: Changed "IGM Path:" to "Database Path:".}
END; { EXIT_SCREEN ============================================ }


BEGIN    { Main JACKEDIT.pas BEGIN/END structure }
  ClrScr;

  CursorOff;                  {Gold Tool-Kit process}
  UseLordColors:= TRUE;

  Debug_Mode:= FALSE;   {Added 12/02/07}

  IF S2U(ParamStr(1)) = '/DEBUG'  {Added 12/02/07}
    THEN Debug_Mode:= True;

  ReadVars.ReadHelp:= NIL;  { removes the HELP button in the prompts. }   {Gold toolkit process}

  WinNoClose:= TRUE;        { removes the prompt window close
                             button in upper left. }      {Gold toolkit process}

  RecordNum:= 0;

  IF Exist('JACKPLAY.DAX') THEN DeleteFile('JACKPLAY.DAX');  {07/28/05}

  READ_CONFIG;  {process existing jackedit.cfg file.}

  { ===================== Added 08/12/2005 ================== }
  Editor_Path:= S2U(IGMDIR+GemPlayer_FN);  {12/07/06: added S2U}
             { 12/31/07: Renamed Peddler_FN to Editor_Path. }

  { 12/06/06: Attempts to run JACKDIT from compiler are not working. }
  { 12/06/06: IGMDir, GemPlayer_FN, and Peddler_FN all have valid values. }
  { For unknown reason, the IF EXIST(Peddler_FN) command works fine when }
  { program is run from DOS, but it WON't work when program is run by BPW. }

  IF Exist(Editor_Path) THEN READ_CUSTOMERS_FILE   {08/12/05 code block}
  ELSE
    BEGIN
      CWriteLn(' ');
      CWriteLn('  `@ERROR:  `0JACKEDIT `!could not locate `@The Gem Trader''s ');
      CWriteLn('  `#JACKPLAY.DAT `!file, which is `%REQUIRED `!for you to edit ');
      CWriteLn('  `!the IGM''s database records.');

      CWriteLn(' ');
      CWriteLn('  `0JACKEDIT `!looked for this file, which was not found: ');
      CWriteLn('    `$'+Editor_Path);
             { 12/31/07: Renamed Peddler_FN to Editor_Path. }

      CWriteLn(' ');   {12/18/09}
      CWriteLn('  `#Problem Solving Note: `%Make sure the `!JACKEDIT.CFG `%file contains ');
                     {12/18/09: verified 12/30/09}
      CWriteLn('  `%the correct path to where the IGM''s data files are located.');      {12/18/09}

      CWriteLn(' ');
      CWriteLn('  `!Terminating `0JACKEDIT `!after 3 seconds delay.  ');
                {12/06/06: changed "immediately." to "after 3 seconds delay."}

      DELAY(3000);   {Added 12/06/06; debug code}
      HALT;
    END;
  { =========================================================== }

  RUN_EDITOR;

  EXIT_SCREEN;  {12/27/05: renamed ExitScreen to Exit_Screen}

  ResetStartUpMode;     {Gold toolkit process}
END. { JACKEDIT.pas }


   {12/05/06: Added "Database" to program name.}

  { Started creation using ShopEdit source code 07/19/2005. }
  { Eliminated need for JACKUNIT.pas unit file on 08/20/2005. }
  { Finished development, and released v1.00 officially on 02/26/2006. }

  { The Gem Trader v2.50: Officially released December 28th, 2006. }
  { JackConv v1.00/JackEdit v1.10: Officially released December 28th, 2006. }
  {12/06/06: placed Chasware unit before LordLock unit.}
  {12/06/06: Stopped using LordLock unit. }
  {12/05/06: changed to v1.10}
  {12/06/06: added :STRING to statement.}

{ CONST Vers110_Date : STRING = 'December 28th, 2006.'; }  {12/05/06}

  { 12/31/07: Replaced Peddler_FN with Editor_Path. }

      {12/07/06: removed Config_File VAR from INC file.}

{11/20/07: used v1.11 Beta.  12/15/07: used v1.15 beta}
{10/13/07: Replaced all GEMDRINK.DAT references with JACKPLAY.DAT. }

      { 12/05/06: IGM no longer uses Fairy/Horse trade limits. }
      {   Dropped use of Max_Fairies, Max_Horses, Max_Kids.  }
      { 12/05/06: Used 9,000 in Editor instead of Max_Kids. }
      { 12/05/06: For Fairies, Horses, Saddles, HorseShoes  }
      {   editor data editing range limits, used 0-100. }

      { 08/21/05: Dropped use of Max_Gems_Traded constant. }

      { Visits: Limited to 10 per day. Fairy Trades: 12/day limit. }
      { Adoptions: 16,000 per day limit used, as of 12/28/2006. }

             { 07/29/05: Renamed Editor_FN to Peddler_FN. }
             { 12/31/07: Renamed Peddler_FN to Editor_Path. }
    {12/06/06: Deleted Record_Num: WORD command.}
      { 12/02/07: Changed menu code from X to S for Player Search. }
      { Moved TwoBillion VAR here 08/20/05 from JACKUNIT.PAS file }
  {12/06/06: Changed F VAR to Config_File.}
  {12/06/06: Renamed READCONFIG to READ_CONFIG.}

{12/02/07: Renamed READ_TRADERS_FILE to READ_CUSTOMERS_FILE.}

{12/02/07: Renamed WRITE_TRADERS_FILE to WRITE_CUSTOMERS_FILE.}
    { Moved here from JACKUNIT on 08/20/05 }
{12/02/07: Renamed Search to PLAYER_SEARCH. }

    { Moved GET Func here from JACKUNIT on 08/20/05 }

      {  Release_Date : STRING = 'Dec. 16th, 2007.';  }   {12/16/07}

{ No point in having Delete Player in this IGM. DeletePlayer process was removed. }


{  Moved Do_PlayerSearch below SHOW_MENU 08/20/05. }

            {11/28/09: changed to v1.23 beta}

       { 08/19/05: Added K menu code. } {01/17/10: Added X code.}
       { 12/02/07: Changed menu code from X to S for Player Search. }

